function [ Jmu, UNUN ] = music( H, B, mu )
%

% inputs:
% H(Nc,Nv): lead field   
% B(Nc,Nt): sensor data   
%
% outputs:
% Jmu(Nv): MUSIC localizer scanning results
%
  [~,Nt]=size(B);
    Nv=size(H,2);
%
% computing covariance matrix
%    
  Rzz=B*B'/Nt;
%
% eigen decomposition of Rzz
%
[U,S]=eig(Rzz);
eig_els=abs(diag(S));
[eig_el, iorder]=sort(-eig_els); eig_el=-eig_el;
U(:,:)=U(:,iorder);
ev_max=length(eig_el);

% figure(33)
% plot(1:ev_max,eig_el,'-o')
% axis([1,ev_max, 0, eig_el(1)*1.1])
% title('eigen value spectrum of covariance matrix')
% xlabel('order of eigenvalues')
% ylabel('relative magnitude')
%

% mu= input('enter the dimension of signal subspace : '); %muςꍇRg͂D
UN = U(:,mu+1:end);             
UNUN=UN*UN';     
%
% noise subspace projector  
%
%  matrix preallocation ------------------------
%
  Jmu=zeros(Nv,1);
%          
for iv=1:Nv
      hv=H(:,iv); 
     Jmu(iv)=1/(hv'*UNUN*hv);
end
 
end

