function [ Phat, Shat ] = beamformer( H, B, Ps )
%
% beamformerASY
%------------------------------------
%  programmed by K. Sekihara
%  All right reserved by K. Sekihara
%  {R[h̎gpɍۂĂREADME.pdfɂgpmFĂ
%---------------------------------------------------------
% inputs:
% H(Nc,Nv): lead field   
% B(Nc,Nt): sensor data   
%
% outputs:
% Phat(Nv): power outputs
% Shat(Nv,Nt): beamformer estimate of voxel time courses
%
% if ESES==[] (empty), eigenspace projection NOT implemented.
% if ESES~=[] (non-empty), eigenspace projection implemented.
%
  [~,Nt]=size(B);
    Nv=size(H,2);
%    
  Rzz=B*B'/Nt; %f[^TvUšvZ
  iRzz=inv(Rzz);
%
%  r[tH[}[XLjO
%
 Phat=zeros(Nv,1);
 Shat=zeros(Nv,Nt);
%          
for iv=1:Nv
     hv=H(:,iv); 
     xi=1/(hv'*iRzz*hv);
     ww=xi*iRzz*hv; 
     if isempty(Ps)==0
         eww=Ps*ww;
         Shat(iv,:)=eww'*B;
     else
         Shat(iv,:)=ww'*B;
     end
     Phat(iv)=xi;
end
 
end

