function [ Jmu, Pn ] = music( H, B, mu )
% MUSICASY
%------------------------------------
%  programmed by K. Sekihara
%  All right reserved by K. Sekihara
%  {R[h̎gpɍۂĂREADME.pdfɂgpmFĂ
%---------------------------------------------------------
% inputs:
% H(Nc,Nv): lead field   
% B(Nc,Nt): sensor data   
%
% outputs:
% Jmu(Nv): MUSIC localizer scanning results
% Pn(Nc,Nc): noise subspace projector
%
  [~,Nt]=size(B);
    Nv=size(H,2);
%
% computing covariance matrix
%    
  Rzz=B*B'/Nt;
%
% eigen decomposition of Rzz
%
[U,S]=eig(Rzz);
eig_els=abs(diag(S));
[eig_el, iorder]=sort(-eig_els); eig_el=-eig_el;
U(:,:)=U(:,iorder);
ev_max=length(eig_el);
% mu= input('enter the dimension of signal subspace : '); %muςꍇRg͂D
UN = U(:,mu+1:end);             
Pn=UN*UN';    % noise subspace projector  
%
%MUSICXL
  Jmu=zeros(Nv,1);
for iv=1:Nv
      hv=H(:,iv); 
     Jmu(iv)=1/(hv'*Pn*hv);
end
 
end

