function [dlabel] = labelData(pdata, hmu, hSigma, hpi)
%
% hgam(Nt,Nk)
%
% pdata(Nt,Nk)
% hmu(Nk,2)
% hSigma(2,2,Nk)
% hpi(Nk)
%
[Nt,~]=size(pdata);
dlabel=zeros(Nt,1);
%
for it=1:Nt
    xn=pdata(it,:);                % extracting xn
    hmu1=hmu(1,:);                 % mu1
    hSigma1=hSigma(:,:,1);         % Sigma1
    gauss1=mvnpdf(xn,hmu1,hSigma1);  %N(xn|mu1,Sigma1)
    pp1=hpi(1)*gauss1;             % posterior probability:(8.49)式の分子
 %
    hmu2=hmu(2,:);                   % mu2
    hSigma2=hSigma(:,:,2);           % Sigma2
    gauss2=mvnpdf(xn,hmu2,hSigma2);  % N(xn|mu2,Sigma2)
    pp2=hpi(2)*gauss2;               % posterior probability:(8.49)式の分子
%
% (8.49)式の分子をk=1とk=2で比較し，k=1の事後確率が大きければラベルを1とする．
  if pp1>pp2
      dlabel(it)=1;
  end
%
end

